package net.brokenmoon.redcontrol;

import net.brokenmoon.redcontrol.blocks.TerminalEntity;
import net.brokenmoon.redcontrol.screen.CpuScreen;
import net.brokenmoon.redcontrol.screen.TerminalScreen;
import net.fabricmc.api.ClientModInitializer;
import net.fabricmc.fabric.api.client.networking.v1.ClientPlayNetworking;
import net.minecraft.client.world.ClientWorld;
import net.minecraft.text.Text;
import net.minecraft.util.math.BlockPos;

import java.util.Optional;

public class RedControlClient implements ClientModInitializer {
	@Override
	public void onInitializeClient() {
		// This entrypoint is suitable for setting up client-specific logic, such as rendering.
		ClientPlayNetworking.registerGlobalReceiver(
				RedControlNetworking.CPUGUI_PACKET_ID, (client, handler, buf, responseSender) -> {
					BlockPos blockPos = buf.readBlockPos();
					client.execute(() -> client.setScreen(new CpuScreen(Text.literal("cpu"), blockPos)));
				});
		ClientPlayNetworking.registerGlobalReceiver(
				RedControlNetworking.MONITOR_PACKET_ID, (client, handler, buf, responseSender) -> {
					BlockPos blockPos = buf.readBlockPos();
					ClientWorld cw = client.world;
					if (cw != null) {
						Optional<TerminalEntity> te = cw.getBlockEntity(blockPos,RedControl.TERMINAL_BLOCK_ENTITY);
						if (te.isEmpty()) {
							RedControl.LOGGER.warn("Server just sent us a Terminal packet, terminal is not at position given {}?",blockPos);
							return;
						}
						client.execute(() -> client.setScreen(new TerminalScreen(te.get())));
					} else {
						RedControl.LOGGER.warn("Server just send us a packet... we dont have a world... HOW");
					}
				});
		Shaders.INSTANCE.init();
	}
}