package net.brokenmoon.redcontrol.api;

import com.simon816.j65el02.device.RedBus;
import net.brokenmoon.redcontrol.blocks.NetworkCarrier;
import net.minecraft.server.world.ServerWorld;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

/**
 * A Bus holder including the blockpos and redbus and a cached world
 * also holds if the bus is valid
 */
public class RCWorldBus {

    private boolean isValid = false;

    private RedBus redBus;

    private World backupWorld;
    private BlockPos backupPos;

    public RCWorldBus(RedBus redBus, World world, BlockPos pos) {
        this.redBus = redBus;
        backupWorld = world;
        backupPos = pos;
    }


    
    public void generateBus(ServerWorld world, BlockPos pos){
        ((NetworkCarrier)(world.getBlockState(pos).getBlock())).generateBus(world, pos);
    }

    public RedBus getRedBus() {
        return redBus;
    }

    public void setRedBus(RedBus redBus) {
        this.redBus = redBus;
    }

    public void setValid(boolean val){
        this.isValid = val;
    }

    public boolean getValid(){
        return this.isValid;
    }
}
