package net.brokenmoon.redcontrol.api.events;

import net.fabricmc.fabric.api.event.Event;
import net.fabricmc.fabric.api.event.EventFactory;
import net.minecraft.block.BlockState;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import org.jetbrains.annotations.NotNull;


public class BlockModificationEvents {
    /**
     * this event is triggered when a blockstate is changed.
     */
    public static Event<OnStateChange> ON_CHANGE = EventFactory.createArrayBacked(OnStateChange.class, callbacks -> (world,blockPos,oldState,newState) -> {
        for (OnStateChange callback : callbacks) {
            callback.onChange(world, blockPos,oldState,newState);
        }
    });
    public @FunctionalInterface interface OnStateChange {void onChange(@NotNull  World world,@NotNull BlockPos blockPos,@NotNull BlockState oldState, @NotNull BlockState newState);}

}
