package net.brokenmoon.redcontrol.blocks;

import com.mojang.serialization.MapCodec;
import net.brokenmoon.redcontrol.RedControl;
import net.brokenmoon.redcontrol.RedControlNetworking;
import net.brokenmoon.redcontrol.blockentities.CpuEntity;
import net.fabricmc.fabric.api.networking.v1.PacketByteBufs;
import net.fabricmc.fabric.api.networking.v1.ServerPlayNetworking;
import net.minecraft.block.*;
import net.minecraft.block.entity.BlockEntity;
import net.minecraft.block.entity.BlockEntityTicker;
import net.minecraft.block.entity.BlockEntityType;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.network.PacketByteBuf;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;
import net.minecraft.util.ActionResult;
import net.minecraft.util.Hand;
import net.minecraft.util.hit.BlockHitResult;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import org.jetbrains.annotations.Nullable;

public class CpuBlock extends NetworkCarrier {
    public CpuBlock(Settings settings) {
        super(settings);
    }

    @Override
    protected MapCodec<? extends BlockWithEntity> getCodec() {
        return null;
    }

    @Nullable
    @Override
    public BlockEntity createBlockEntity(BlockPos pos, BlockState state) {
        return new CpuEntity(pos, state);
    }

    @Override
    public <T extends BlockEntity> BlockEntityTicker<T> getTicker(World world, BlockState state, BlockEntityType<T> type) {
        return validateTicker(type, RedControl.CPU_BLOCK_ENTITY, CpuEntity::tick);
    }

    @Override
    public ActionResult onUse(BlockState state, World world, BlockPos pos, PlayerEntity player, Hand hand, BlockHitResult hit) {
        if (!world.isClient) {
            if (player.getStackInHand(hand).getItem() == RedControl.SQUEAKY_HAMMER) {
                super.onUse(state,world,pos,player,hand,hit);
                CpuEntity peripheral = (CpuEntity) world.getBlockEntity(pos);
                player.sendMessage(Text.literal("Cpu Debug: "), false);
                player.sendMessage(Text.literal("  " + Integer.toHexString(peripheral.i)), false);
                player.sendMessage(Text.literal("  " + peripheral.core.isWaitingOnInterrupt()), false);
                player.sendMessage(Text.literal("  " + peripheral.core.cpu.getCpuState().toTraceEvent()));
            }
            PacketByteBuf byteBuf = PacketByteBufs.create();
            byteBuf.writeBlockPos(pos);
            ServerPlayNetworking.send((ServerPlayerEntity) player, RedControlNetworking.CPUGUI_PACKET_ID,byteBuf);
        }

        return ActionResult.SUCCESS;
    }

}
