package net.brokenmoon.redcontrol.mixin;

import net.brokenmoon.redcontrol.api.events.BlockModificationEvents;
import net.minecraft.block.BlockState;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import org.spongepowered.asm.mixin.Debug;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.Unique;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Debug(export = true, print = true)
@Mixin(World.class)
public abstract class WorldMixin {
    @Unique
    private BlockState old;

    @Shadow
    public BlockState getBlockState(BlockPos pos) {return null;}

    @Inject(method = "setBlockState(Lnet/minecraft/util/math/BlockPos;Lnet/minecraft/block/BlockState;II)Z", at = @At("RETURN"))
    private void hookBlockPlace(BlockPos pos, BlockState state, int flags, int maxUpdateDepth, CallbackInfoReturnable<Boolean> cir) {
        World world = (World)(Object)this;
        //IDEA says that this is unreachable but it is reachable.
        if (cir.getReturnValue() && !world.isClient()) {
            BlockModificationEvents.ON_CHANGE.invoker().onChange(world,pos,this.old,state);
        }
    }

    @Inject(method = "setBlockState(Lnet/minecraft/util/math/BlockPos;Lnet/minecraft/block/BlockState;II)Z", at = @At("HEAD"))
    private void hookBlockRemove(BlockPos pos, BlockState state, int flags, int maxUpdateDepth, CallbackInfoReturnable<Boolean> cir) {
            this.old = getBlockState(pos);
    }
}
